import itertools
import math

n = int(input())
points = [list(map(int, input().split())) for _ in range(n)]

distances = [[0] * n for _ in range(n)]

for i in range(n):
    for j in range(n):
        distances[i][j] = math.sqrt((points[i][0] - points[j][0]) ** 2 + (points[i][1] - points[j][1]) ** 2)

min_distance = float('inf')

for perm in itertools.permutations(range(n)):
    distance = sum(distances[perm[i]][perm[i+1]] for i in range(n-1))
    min_distance = min(min_distance, distance)

print(min_distance)